/*
 * Class_Serial.hpp
 *
 * Created: 2016/02/17 14:01:04
 *  Author: Yuhei MATSUMURA
 */ 

#ifndef CLASS_SERIAL_H_
#define CLASS_SERIAL_H_


#include <avr/io.h>
#define QUEUE_MAX 128

class Class_Serial{
	volatile uint8_t *UCSRnA;
	volatile uint8_t *UCSRnB;
	volatile uint8_t *UCSRnC;
	volatile uint16_t *UBRRn;
	volatile uint8_t *UDRn;
	uint8_t head;
	uint8_t tail;
	uint8_t queue_num;
	uint8_t buffer[QUEUE_MAX];
public:
	Class_Serial(volatile uint8_t *setUCSRnA, volatile uint8_t *setUCSRnB, volatile uint8_t *setUCSRnC, volatile uint16_t *setUBRRn, volatile uint8_t *setUDRn);
	void begin(uint16_t SPD_UBRRn);
	void accept_intterupt();
	void send_char(uint8_t input);
	void send_print(const char *input);
	void send_println(const char *input);
	void send_figure(uint8_t input);
	void send_br();
	void send_num(int16_t input);
	void send_num(int32_t input);
	void receive_enqueue();
	uint8_t read_dequeue();
	uint8_t available();
};


#endif /* CLASS_SERIAL_H_ */
